/* **************************************************** *
 * This file describes the datastructures for handling  *
 * private variables and arrays, this is necessary      *
 * because variables that are private need to stay in   *
 * scope between different step-statements, this was    *
 * not an issue when using the cluster-approach for     *
 * the NestStep-C implementation.                       *
 * **************************************************** */

#ifndef COMMON_VAR_H
#define COMMON_VAR_H

#include "common_base.h"

typedef struct _pvar {
    Name name; // scope
    int type; // IVAL, FVAL, DVAL
    Addr64 base;	// address in main memory of the data
    //    char* uspaceName; // userspace name, used by the user to get the data
    //    int no; // used to find the variable when more than one exists (i.e. arrays)
    Dma_tag* tag; // mfc-tag so we can wait for the variable to finish
    struct _pvar* next; //for handling of the linked list in the dataManagers
    struct _pvar* prev; //for handling of the linked list in the dataManagers
} PVar;

typedef struct _shvar {
    Name name; // scope
    int type; // IVAL, FVAL, DVAL
    Addr64 base;	// address in main memory of the data
    //    char* uspaceName; // userspace name, used by the user to get the data
    //    int no; // used to find the variable when more than one exists (i.e. arrays)
    Dma_tag* tag; // mfc-tag so we can wait for the variable to finish
    struct _shvar* next; //for handling of the linked list in the dataManagers
    struct _shvar* prev; //for handling of the linked list in the dataManagers
} ShVar;


//creators and destructors are in the ppulib with callers in spulib
//getters and setters are in the spulib

#endif // COMMON_VAR_H
