################################################################################
# Make rules
################################################################################

#TOOLCHAIN_HOME=/opt/sce/toolchain-2.3
TOOLCHAIN_HOME=/opt/cell/toolchain-3.3
DEVEL_HOME=/home/astrolite/code/CELL/tmphome

################################################################################
# ppu compiler definition
################################################################################
#ppeCXXINCLUDES=-isystem $(TOOLCHAIN_HOME)/ppu/sysroot/usr/include \
#	-I /opt/cell/sysroot/usr/include \
#	-I . -I .. -I ${DEVEL_HOME}
ppeCXXINCLUDES=-isystem $(TOOLCHAIN_HOME)/sysroot/usr/include \
	-I . -I .. -I ${DEVEL_HOME}


#ppeLDFLAGS=-L /opt/IBM/cell-sdk-1.1/sysroot/usr/lib -lspe -lpthread 
#ppeLDFLAGS=-L /opt/ibm/cell-sdk/prototype/sysroot/usr/lib/ -lspe2 -lpthread
ppeLDFLAGS=-L /opt/ibm/cell-sdk/prototype/sysroot/usr/lib/ -lspe -lpthread
#ppeLDFLAGS=-L /opt/IBM/cell-sdk-1.1/sysroot/usr/lib64 -lspe -lpthread
#ppeLDFLAGS=-L /opt/ibm/cell-sdk/prototype/sysroot/usr/lib64 -lspe2 -lpthread

ppeCXX=ppu-g++
ppe_altivec=-mabi=altivec -maltivec -m32
#ppe_altivec=-mabi=altivec -maltivec -m64

ppe_optflags=-O3
ppeCXXLFLAGS=-x c++
ppeCXXFLAGS=${ppe_optflags} ${ppe_altivec}
#ppeCINCLUDES=-I /opt/IBM/cell-sdk-1.1/sysroot/usr/include -I .. -I . -I ${DEVEL_HOME}
ppeCINCLUDES=-I /opt/ibm/cell-sdk/prototype/sysroot/usr/include -I .. -I . -I ${DEVEL_HOME}

ifeq "${PPU_COMPILER}" "ppuxlc"
	ppeCC=ppuxlc
	ppe_optflags=-O3
	ppe_altivec=-D __ALTIVEC_LITERAL_STYLE__ -qcpluscmt
	ppeCFLAGS=${ppe_optflags} ${ppe_altivec}
	ppeCLFLAGS=-qsourcetype=c -fPIC
else
	ppeCC=ppu-gcc
	ppe_optflags=-O3
	ifeq "${CELLBUILDTYPE}" "DEBUG"
		ppeCFLAGS=${ppe_optflags} -m32 -fstack-check -g
	else
		ppeCFLAGS=${ppe_optflags} -m32
	endif
#	ppeCFLAGS=${ppe_optflags} -m64 -fstack-check -g
	ppeCLFLAGS=-x c -fPIC -Wall
endif


%.o: %.c
	${ppeCC} ${ppeCFLAGS} ${ppeCLFLAGS} ${ppeCINCLUDES} -c $< -o $@

%.o: %.cxx
	${ppeCXX} ${ppeCXXFLAGS} ${ppeCXXLFLAGS} ${ppeCXXINCLUDES} -c $< -o $@

# subdirs
.PHONY : subdirs ${SUBDIRS}

subdirs: ${SUBDIRS}

${SUBDIRS}:
	${MAKE} -C $@ ${MAKECMDGOALS}

# clean
.PHONY : clean

clean: ${SUBDIRS}
	rm -rf *.o *.lst libNestStep_ppulib.so ${TARGETS}
