#include "combine_ppu.h"
//TODO: is it possible to write cleaner expressions without pointer-black-magic?
// replace: tmp_prefixvar += (((double*)rarrs[j]->base.p)[i+rarrs[j]->url]);
// for example with something like:
// double* tmp_rarr[GROUP_SIZE] = ((double*)rarrs[j]->base.p + rarrs[j]->url);
// tmp_prefixvar += tmp_rarr[j][i];

void handle_RArrI(RepArrayInfo** rarris, RepArray** rarrs, int combine_strategy, int size){
    int i, j, tmp_prefixvar;
    int* tmp_rarr;
    //init the RArrI       
    tmp_rarr = malloc(size*sizeof(int));
    //combine
    
    for(i=0;i<size;i++){
	tmp_rarr[i] = ((int*)rarrs[0]->base.p)[i+rarrs[0]->url];
	//manage prefix-var
	tmp_prefixvar = 0;
	if(rarris[0]->prefix_tag == PREFIX){
	    ((int*)rarris[0]->prefix_base)[i] = tmp_prefixvar;
	    tmp_prefixvar += (((int*)rarrs[0]->base.p)[i+rarrs[0]->url]);
	}
	for(j=1;j<GROUP_SIZE;j++){
	    switch(combine_strategy){
	    case ADD:
		tmp_rarr[i] += ((int*)rarrs[j]->base.p)[i+rarrs[j]->url];
		break;
	    case MULT:
		tmp_rarr[i] *= ((int*)rarrs[j]->base.p)[i+rarrs[j]->url];
		break;
	    case AND:
		tmp_rarr[i] &= ((int*)rarrs[j]->base.p)[i+rarrs[j]->url];
		break;
	    case OR:
		tmp_rarr[i] |= ((int*)rarrs[j]->base.p)[i+rarrs[j]->url];
		break;
	    case COMBINE_MAX:
		tmp_rarr[i] = (tmp_rarr[i] > ((int*)rarrs[j]->base.p)[i+rarrs[j]->url])?
		    tmp_rarr[i]:((int*)rarrs[j]->base.p)[i+rarrs[j]->url];
		break;
	    case COMBINE_MIN:
		tmp_rarr[i] = (tmp_rarr[i] < ((int*)rarrs[j]->base.p)[i+rarrs[j]->url])?
		    tmp_rarr[i]:((int*)rarrs[j]->base.p)[i+rarrs[j]->url];
		break;
	    case UPDATED:
		if(rarris[j]->updated == j){
		    tmp_rarr[i] = ((int*)rarrs[j]->base.p)[i+rarrs[j]->url];
		}
		break;
		//NOTE: all following will work as LEADER
	    case FUNC:
		break;
	    case LEADER:
		break;
	    }
	    if(rarris[j]->prefix_tag == PREFIX){
		((int*)rarris[j]->prefix_base)[i] = tmp_prefixvar;
		tmp_prefixvar += (((int*)rarrs[j]->base.p)[i+rarrs[j]->url]);
	    }
	}
    }
    //store
    for(j=0;j<GROUP_SIZE;j++){
	memcpy(&(((int*)rarrs[j]->base.p)[rarrs[j]->url]),tmp_rarr,sizeof(int)*size);
	//	memcpy(rarrs[j]->base.p,tmp_rarr,sizeof(int)*size);
    }
    free(tmp_rarr);
}
void handle_RArrF(RepArrayInfo** rarris, RepArray** rarrs, int combine_strategy, int size){
    int i, j;
    float tmp_prefixvar;
    float* tmp_rarr;
    //init the RArrF
    tmp_rarr = malloc(size*sizeof(float));

    //combine
    for(i=0;i<size;i++){
	tmp_rarr[i] = ((float*)(rarrs[0]->base.p))[i+rarrs[0]->url];
	//handle prefix-vars
	tmp_prefixvar = 0;
	if(rarris[0]->prefix_tag == PREFIX){
	    ((float*)rarris[0]->prefix_base)[i] = tmp_prefixvar;
	    tmp_prefixvar += (((float*)rarrs[0]->base.p)[i+rarrs[0]->url]);
	}
	for(j=1;j<GROUP_SIZE;j++){
	    switch(combine_strategy){
	    case ADD:
		tmp_rarr[i] += ((float*)rarrs[j]->base.p)[i+rarrs[j]->url];
		break;
	    case MULT:
		tmp_rarr[i] *= ((float*)rarrs[j]->base.p)[i+rarrs[j]->url];
		break;
	    case COMBINE_MAX:
		tmp_rarr[i] = (tmp_rarr[i] > ((float*)rarrs[j]->base.p)[i+rarrs[j]->url])?
		    tmp_rarr[i]:((float*)rarrs[j]->base.p)[i+rarrs[j]->url];
		break;
	    case COMBINE_MIN:
		tmp_rarr[i] = (tmp_rarr[i] < ((float*)rarrs[j]->base.p)[i+rarrs[j]->url])?
		    tmp_rarr[i]:((float*)rarrs[j]->base.p)[i+rarrs[j]->url];
		break;
	    case UPDATED:
		if(rarris[j]->updated == j){
		    tmp_rarr[i] = ((float*)rarrs[j]->base.p)[i+rarrs[j]->url];
		}
		break;
		//NOTE: all following will work as LEADER
	    case AND:
		//NOTE: comment out? yes, cant &/| floats
		//tmp_rarr[i] &= ((float*)rarrs[j]->base.p)[i+rarrs[j]->url];
		break;
	    case OR:
		//NOTE: comment out? yes, cant &/| floats
		//tmp_rarr[i] |= ((float*)rarrs[j]->base.p)[i+rarrs[j]->url];
		break;
	    case FUNC:
		break;
	    case LEADER:
		break;
	    }
	    if(rarris[j]->prefix_tag == PREFIX){
		((float*)rarris[j]->prefix_base)[i] = tmp_prefixvar;
		tmp_prefixvar += (((float*)rarrs[j]->base.p)[i+rarrs[j]->url]);
	    }
	}
    }
    //store
    for(j=0;j<GROUP_SIZE;j++){
	memcpy(&(((float*)rarrs[j]->base.p)[rarrs[j]->url]),tmp_rarr,sizeof(float)*size);
	//	memcpy(rarrs[j]->base.p,tmp_rarr,sizeof(float)*size);
    }
    free(tmp_rarr);
}
void handle_RArrD(RepArrayInfo** rarris, RepArray** rarrs, int combine_strategy, int size){
    int i, j;
    double tmp_prefixvar;
    double* tmp_rarr;
    //init the RArrD
    tmp_rarr = malloc(size*sizeof(double));
    //combine
    for(i=0;i<size;i++){
	tmp_rarr[i] = ((double*)(rarrs[0]->base.p))[i+rarrs[0]->url];
	//handle prefix-vars
	tmp_prefixvar = 0;
	if(rarris[0]->prefix_tag == PREFIX){
	    ((double*)rarris[0]->prefix_base)[i] = tmp_prefixvar;
	    tmp_prefixvar += (((double*)rarrs[0]->base.p)[i+rarrs[0]->url]);
	}

	for(j=1;j<GROUP_SIZE;j++){
	    switch(combine_strategy){
	    case ADD:
		tmp_rarr[i] += ((double*)rarrs[j]->base.p)[i+rarrs[j]->url];
		break;
	    case MULT:
		tmp_rarr[i] *= ((double*)rarrs[j]->base.p)[i+rarrs[j]->url];
		break;
	    case COMBINE_MAX:
		tmp_rarr[i] = (tmp_rarr[i] > ((double*)rarrs[j]->base.p)[i+rarrs[j]->url])?
		    tmp_rarr[i]:((double*)rarrs[j]->base.p)[i+rarrs[j]->url];
		break;
	    case COMBINE_MIN:
		tmp_rarr[i] = (tmp_rarr[i] < ((double*)rarrs[j]->base.p)[i+rarrs[j]->url])?
		    tmp_rarr[i]:((double*)rarrs[j]->base.p)[i+rarrs[j]->url];
		break;
	    case UPDATED:
		if(rarris[j]->updated == j){
		    tmp_rarr[i] = ((double*)rarrs[j]->base.p)[i+rarrs[j]->url];
		}
		break;
		//NOTE: all following will work as LEADER
	    case AND:
		//NOTE: comment out? yes, &/| dont work on double
		//tmp_rarr[i] &= ((double*)rarrs[j]->base.p)[i+rarrs[j]->url];
		break;
	    case OR:
		//NOTE: comment out? yes, &/| dont work on double
		//tmp_rarr[i] |= ((double*)rarrs[j]->base.p)[i+rarrs[j]->url];
		break;
	    case FUNC:
		break;
	    case LEADER:
		break;
	    }
	    if(rarris[j]->prefix_tag == PREFIX){
		((double*)rarris[j]->prefix_base)[i] = tmp_prefixvar;
		tmp_prefixvar += (((double*)rarrs[j]->base.p)[i+rarrs[j]->url]);
	    }
	}
    }

    //store
    for(j=0;j<GROUP_SIZE;j++){
	memcpy(&(((double*)rarrs[j]->base.p)[rarrs[j]->url]),tmp_rarr,sizeof(double)*size);
	//	memcpy(rarrs[j]->base.p,tmp_rarr,sizeof(double)*size);
    }
    free(tmp_rarr);
}
void handle_RepArrays(DataManager* dataManagers){
    int i, j, size,combine_strategy;
    //used to hold pointers to current array
    RepArrayInfo* cur_rarris[MAX_SPE_THREADS];
    RepArray* cur_rarrs[MAX_SPE_THREADS];

    for(i=0;i<GROUP_SIZE;i++){
	cur_rarris[i] = dataManagers[i].thisgroup->clist->rep_info;
	cur_rarrs[i] = NULL;
    }

    while(cur_rarris[0] != NULL){
	combine_strategy = cur_rarris[0]->combine_strategy;

	for(j=0;j<GROUP_SIZE;j++){
	    //select current RepArray
	    cur_rarrs[j] = cur_rarris[j]->rep_array;
	}
	size = cur_rarrs[0]->urh - cur_rarrs[0]->url+1;
	
	switch(cur_rarrs[0]->type){
	case IVAR:
	    handle_RArrI(cur_rarris, cur_rarrs,combine_strategy,size);
	    break;
	case FVAR:
	    handle_RArrF(cur_rarris, cur_rarrs,combine_strategy,size);
	    break;
	case DVAR:
	    handle_RArrD(cur_rarris, cur_rarrs,combine_strategy,size);
	    break;
	}
	//TODO: memory leak, free the RepArrayInfos
	for(j=0;j<GROUP_SIZE;j++){
	    cur_rarris[j] = cur_rarris[j]->next;
	}
    }
}
void handle_ShVarI(CombineInfo** cinfos, ShVar** shvars, int combine_strategy){
    int tmp_shvar,i, tmp_prefixvar;
    tmp_shvar = (*((int*)shvars[0]->base.p));
    //add the prefix-variable
    tmp_prefixvar = 0;
    if(cinfos[0]->prefix_tag == PREFIX){
	*((int*)cinfos[0]->prefix_base) = tmp_prefixvar;
	tmp_prefixvar += *((int*)((int*)shvars[0]->base.p));
    }
    
    for(i=1;i<GROUP_SIZE;i++){
	switch(combine_strategy){
	case ADD:
	    tmp_shvar += *((int*)shvars[i]->base.p);
	    break;
	case MULT:
	    tmp_shvar *= *((int*)shvars[i]->base.p);
	    break;
	case AND:
	    tmp_shvar &= *((int*)shvars[i]->base.p);
	    break;
	case OR:
	    tmp_shvar |= *((int*)shvars[i]->base.p);
	    break;
	case COMBINE_MAX:
	    tmp_shvar = (tmp_shvar > *((int*)shvars[i]->base.p))?
		tmp_shvar:*((int*)shvars[i]->base.p);
	    break;
	case COMBINE_MIN:
	    tmp_shvar = (tmp_shvar < *((int*)shvars[i]->base.p))?
		tmp_shvar:*((int*)shvars[i]->base.p);
	    break;
	case UPDATED:
	    if(cinfos[i]->updated == i){
		tmp_shvar = *((int*)shvars[i]->base.p);
	    }
	    break;
	    //NOTE: all following work as LEADER
	case FUNC:
	    break;
	case LEADER:
	    break;
	}
	if(cinfos[i]->prefix_tag == PREFIX){
	    *((int*)cinfos[i]->prefix_base) = tmp_prefixvar;
	    tmp_prefixvar += *((int*)((int*)shvars[i]->base.p));
	}
    }
    
    for(i=0;i<GROUP_SIZE;i++){
	*((int*)shvars[i]->base.p) = tmp_shvar;
    }
}
void handle_ShVarF(CombineInfo** cinfos, ShVar** shvars, int combine_strategy){
    float tmp_shvar, tmp_prefixvar;
    int i;
    tmp_shvar = (*((float*)shvars[0]->base.p));
    //prefix var
    tmp_prefixvar = 0;
    if(cinfos[0]->prefix_tag == PREFIX){
	*((float*)cinfos[0]->prefix_base) = tmp_prefixvar;
	tmp_prefixvar += *((float*)cinfos[0]->var->base.p);
    }

    for(i=1;i<GROUP_SIZE;i++){
	switch(combine_strategy){
	case ADD:
	    tmp_shvar += *((float*)shvars[i]->base.p);
	    break;
	case MULT:
	    tmp_shvar *= *((float*)shvars[i]->base.p);
	    break;
	case COMBINE_MAX:
	    tmp_shvar = (tmp_shvar > *((float*)shvars[i]->base.p))?
		tmp_shvar:*((float*)shvars[i]->base.p);
	    break;
	case COMBINE_MIN:
	    tmp_shvar = (tmp_shvar < *((float*)shvars[i]->base.p))?
		tmp_shvar:*((float*)shvars[i]->base.p);
	    break;
	case UPDATED:
	    if(cinfos[i]->updated == i){
		tmp_shvar = *((float*)shvars[i]->base.p);
	    }
	    break;
	    //NOTE: all following work as LEADER
	case AND:
	    // tmp_shvar &= *((float*)shvars[i]->base.p);
	    break;
	case OR:
	    //tmp_shvar |= *((float*)shvars[i]->base.p);
	    break;
	case FUNC:
	    break;
	case LEADER:
	    break;
	}
	if(cinfos[i]->prefix_tag == PREFIX){
	    *((float*)cinfos[i]->prefix_base) = tmp_prefixvar;
	    tmp_prefixvar += *((float*)cinfos[i]->var->base.p);
	}
    }
    for(i=0;i<GROUP_SIZE;i++){
	*((float*)shvars[i]->base.p) = tmp_shvar;
    }
}
void handle_ShVarD(CombineInfo** cinfos,ShVar** shvars, int combine_strategy){
    double tmp_shvar, tmp_prefixvar;
    int i;
    tmp_shvar = (*((double*)shvars[0]->base.p));

    //prefix var
    tmp_prefixvar = 0;
    if(cinfos[0]->prefix_tag == PREFIX){
	*((double*)cinfos[0]->prefix_base) = tmp_prefixvar;
	tmp_prefixvar += *((double*)cinfos[0]->var->base.p);
    }
    for(i=1;i<GROUP_SIZE;i++){
	switch(combine_strategy){
	case ADD:
	    tmp_shvar += *((double*)shvars[i]->base.p);
	    break;
	case MULT:
	    tmp_shvar *= *((double*)shvars[i]->base.p);
	    break;
	case COMBINE_MAX:
	    tmp_shvar = (tmp_shvar > *((double*)shvars[i]->base.p))?
		tmp_shvar:*((double*)shvars[i]->base.p);
	    break;
	case COMBINE_MIN:
	    tmp_shvar = (tmp_shvar < *((double*)shvars[i]->base.p))?
		tmp_shvar:*((double*)shvars[i]->base.p);
	    break;
	case UPDATED:
	    if(cinfos[i]->updated == i){
		tmp_shvar = *((double*)shvars[i]->base.p);
	    }
	    break;
	    //NOTE: all following work as LEADER
	case AND:
	    //tmp_shvar &= *((double*)shvars[i]->base.p);
	    break;
	case OR:
	    //tmp_shvar |= *((double*)shvars[i]->base.p);
	    break;
	case FUNC:
	    break;
	case LEADER:
	    break;
	}
	if(cinfos[i]->prefix_tag == PREFIX){
	    *((double*)cinfos[i]->prefix_base) = tmp_prefixvar;
	    tmp_prefixvar += *((double*)cinfos[i]->var->base.p);
	}
    }
    for(i=0;i<GROUP_SIZE;i++){
	*((double*)shvars[i]->base.p) = tmp_shvar;
    }
}
//void update_prefix_var(int datatype){
//    switch(datatype){
//    case IVAR:
//	if(cur_combinfo[j]->prefix_tag == PREFIX){
//	    *((int*)cur_combinfo[j]->prefix_base) = tmp_prefix_var.i;
//	    tmp_prefix_var.i += *((int*)cur_combinfo[j]->var->base.p);
//	}
//	break;
//    case FVAR:
//	if(cur_combinfo[j]->prefix_tag == PREFIX){
//	    *((float*)cur_combinfo[j]->prefix_base) = tmp_prefix_var.f;
//	    tmp_prefix_var.f += *((float*)cur_combinfo[j]->var->base.p);
//	}
//	break;
//    case DVAR:
//	if(cur_combinfo[j]->prefix_tag == PREFIX){
//	    *((double*)cur_combinfo[j]->prefix_base) = tmp_prefix_var.d;
//	    tmp_prefix_var.d += *((double*)cur_combinfo[j]->var->base.p);
//	}
//	break;
//    }
//}
void handle_ShVars(DataManager* dataManagers){
    int i, j,combine_strategy;
    //used to hold pointers to current array
    CombineInfo* cur_combinfo[MAX_SPE_THREADS];
    ShVar* cur_shvars[MAX_SPE_THREADS];

    for(i=0;i<GROUP_SIZE;i++){
	cur_combinfo[i] = dataManagers[i].thisgroup->clist->combine_info;
	cur_shvars[i] = NULL;
    }
  
    while(cur_combinfo[0] != NULL){
	combine_strategy = cur_combinfo[0]->combine_strategy;
	for(j=0;j<GROUP_SIZE;j++){
	    //select current ShVar
	    cur_shvars[j] = cur_combinfo[j]->var;
	}

	switch(cur_shvars[0]->type){
	case IVAR:
	    handle_ShVarI(cur_combinfo, cur_shvars,combine_strategy);
	    break;
	case FVAR:
	    handle_ShVarF(cur_combinfo, cur_shvars,combine_strategy);
	    break;
	case DVAR:
	    handle_ShVarD(cur_combinfo, cur_shvars,combine_strategy);
	    break;
	}
	//TODO: memory leak, free CombineInfos
	for(j=0; j<GROUP_SIZE;j++){
	    cur_combinfo[j] = cur_combinfo[j]->next;
	}
    }
}
void handle_mirror_variable_b(DataManager* dataManagers, BlockArrayInfo* bai, int spu_no){
    //    name = c-/b-arr name
    //    prefixname = p-arr name
    //    type = BARR/CARR
    //    lower = lbound global index
    //    higher = ubound global index

    BlockDistArray* tmp_barr;
    int lbound = bai->lower;
    int ubound = bai->higher;
    int size = ubound-lbound+1; // the +1 comes from transfer(0,1) = size2

    tmp_barr = locate_BlockDistArray(bai->name, &dataManagers[spu_no]);
    int localsize = tmp_barr->localsize;
    int block_no = -1;
    int cur_spu = -1;
    int element_size = get_element_size(tmp_barr->type);
    void* dest = bai->buffer.p;
    void* source = NULL;
    int amount_transfered = 0;
    while(lbound < ubound){
	block_no = lbound/localsize;
	cur_spu = block_no;
	//get the BlockDistArray from the current spu
	tmp_barr = locate_BlockDistArray(bai->name, &dataManagers[cur_spu]);
	if(tmp_barr->lower > lbound || tmp_barr->higher < ubound)
	{	
		printf("block_no miss block\n");
		while(tmp_barr->lower > lbound)
			tmp_barr = locate_BlockDistArray(bai->name, &dataManagers[--cur_spu]);
		while(tmp_barr->higher < ubound)
			tmp_barr = locate_BlockDistArray(bai->name, &dataManagers[++cur_spu]);
	}
	source = tmp_barr->base.p;
	localsize = tmp_barr->localsize;
	//get local index
	int local_lbound = global_local_index_b(tmp_barr,lbound,cur_spu);
	if(local_lbound == OUT_OF_BOUNDS){
	    printf("handle_mirror_variable_b Error, out of bounds!\n");
	    exit(1);
	}
	//printf("localsize: %d, local_lbound: %d, size: %d\n", localsize, local_lbound, size);
	if(local_lbound + size <= localsize){
	    //if we only have to look at this segment
	    //for mirrors
	    //memcpy(dest, source, size);
		//printf("from: %d, size: %d, dest: %x\n", local_lbound, size,dest);
	    memcpy(dest+(amount_transfered*element_size),
		   source+(local_lbound*element_size),
		       element_size*size);
	    break;
	} else {
	    //if we have to look at other segments too
	    //for mirrors
	    //memcpy(dest, source, size);
		printf("part from: %d, size: %d\n", local_lbound, localsize-local_lbound);
	    memcpy(dest+(amount_transfered*element_size),
		   source+(local_lbound*element_size),
		   element_size*(localsize-local_lbound));
	    amount_transfered+=(localsize-local_lbound);
	    lbound += (localsize-local_lbound);
	    size -= (localsize-local_lbound);
#ifdef DEBUG_PPU_MIRROR_UPDATE
	    printf("mirror number: %i, data: %i\n",lbound,*(int*)(source +((localsize+local_lbound)*element_size)));
	    printf("transfer number: %i, data: %i\n",amount_transfered,*(int*)(dest + ((amount_transfered-1)*element_size)));
	    printf("amount_transfered: %i, element_size: %i, local_lbound: %i, lbound: %i, localsize: %i, size: %i\n",
		   amount_transfered,element_size,local_lbound,lbound,localsize,size);
#endif
	}
    }
}
void handle_mirror_variable_c(DataManager* dataManagers, CyclicArrayInfo* cai, int spu_no){
    CyclicDistArray* tmp_carr;

    tmp_carr = locate_CyclicDistArray(cai->name, &dataManagers[spu_no]);

    int blocksize = tmp_carr->blocksize;
    int block_no = -1;
    int cur_spu = -1;
    int lbound = cai->lower;
    int ubound = cai->higher;
    int size = ubound - lbound +1; // the +1 comes from transfer(0,1) = size2
    int element_size = get_element_size(tmp_carr->type);
    void* dest = cai->buffer.p;
    void* source = NULL;
    int amount_transfered = 0;
    while(lbound<ubound){
	block_no = lbound/blocksize;
	cur_spu = block_no % GROUP_SIZE;
	tmp_carr = locate_CyclicDistArray(cai->name,&dataManagers[cur_spu]);
	source = tmp_carr->base.p;
	int local_lbound = global_local_index_c(tmp_carr,lbound,cur_spu);
	if(local_lbound == OUT_OF_BOUNDS){
	    printf("handle_mirror_variable_c Error, out of bounds!\n");
	    exit(1);
	}
	if((local_lbound%blocksize) + size < blocksize){
	    //if we only have to look at this segment
	    //for mirrors
	    //memcpy(dest, source, size);
	    memcpy(dest+(amount_transfered*element_size),
		   source+(local_lbound*element_size),
		   element_size*size);
	    break;
	} else {
	    //if we have to look at other segments too
	    //for mirrors
	    //memcpy(dest, source, size);
	    memcpy(dest+(amount_transfered*element_size),
		   source+(local_lbound*element_size),
		   element_size*(blocksize-(local_lbound%blocksize)));

	    amount_transfered+=(blocksize-(local_lbound%blocksize));
	    lbound += (blocksize-(local_lbound%blocksize));
	    size -= (blocksize-(local_lbound%blocksize));
	}
    }
}
void handle_update_variable_b(DataManager* dataManagers, BlockArrayInfo* bai, int spu_no){
    //    name = c-/b-arr name
    //    prefixname = p-arr name
    //    type = BARR/CARR
    //    lower = lbound global index
    //    higher = ubound global index

    BlockDistArray* tmp_barr;
    int lbound = bai->lower;
    int ubound = bai->higher;
    int size = ubound-lbound + 1; // the +1 comes from transfer(0,1) = size2

    tmp_barr = locate_BlockDistArray(bai->name, &dataManagers[spu_no]);
    int localsize = tmp_barr->localsize;
    int block_no = -1;
    int cur_spu = -1;
    int element_size = get_element_size(tmp_barr->type);
    void* dest = bai->buffer.p;
    void* source = NULL;
    int amount_transfered = 0;
    while(lbound < ubound){
	block_no = lbound/localsize;
	cur_spu = block_no;
	//get the BlockDistArray from the current spu
	tmp_barr = locate_BlockDistArray(bai->name, &dataManagers[cur_spu]);
	source = tmp_barr->base.p;
	//get local index
	int local_lbound = global_local_index_b(tmp_barr,lbound,cur_spu);
	if(local_lbound == OUT_OF_BOUNDS){
	    printf("handle_update_variable_b Error, out of bounds!\n");
	    printf("SPU = %i\n",cur_spu);
	    printf("index = %i\n",lbound);
	    exit(1);
	}
	if(local_lbound + size < localsize){
	    //if we only have to look at this segment
	    //for updates
	    //memcpy(source, dest, size);
	    memcpy(source+(local_lbound*element_size),
		   dest+(amount_transfered*element_size),
		   element_size*size);
	    break;
	} else {
	    //if we have to look at other segments too
	    //for updates
	    //memcpy(source, dest, size);
	    memcpy(source+(local_lbound*element_size),
		   dest+(amount_transfered*element_size),
		   element_size*(localsize-local_lbound));

	    amount_transfered+=(localsize-local_lbound);
	    lbound += (localsize-local_lbound);
	    size -= (localsize-local_lbound);
	}
    }
}
void handle_update_variable_c(DataManager* dataManagers, CyclicArrayInfo* cai, int spu_no){
    CyclicDistArray* tmp_carr;

    tmp_carr = locate_CyclicDistArray(cai->name, &dataManagers[spu_no]);

    int blocksize = tmp_carr->blocksize;
    int block_no = -1;
    int cur_spu = -1;
    int lbound = cai->lower;
    int ubound = cai->higher;
    int size = ubound - lbound + 1; // the +1 comes from transfer(0,1) = size2
    int element_size = get_element_size(tmp_carr->type);
    void* dest = cai->buffer.p;
    void* source = NULL;
    int amount_transfered = 0;
#ifdef DEBUG_PPU_MIRROR_UPDATE
    printf("blocksize: %i\n",blocksize);
    printf("lbound: %i\n",lbound);
    printf("ubound: %i\n",ubound);
#endif
    while(lbound<ubound){
	block_no = lbound/blocksize;
	cur_spu = block_no % GROUP_SIZE;
	tmp_carr = locate_CyclicDistArray(cai->name,&dataManagers[cur_spu]);
	source = tmp_carr->base.p;
	int local_lbound = global_local_index_c(tmp_carr,lbound,cur_spu);
	int local_block_no = local_lbound / blocksize;
	if(local_lbound == OUT_OF_BOUNDS){
	    printf("handle_update_variable_c Error, out of bounds!\n");
	    exit(1);
	}
	if((local_lbound%blocksize) + size < blocksize){
	    //if we only have to look at this segment
	    //for updates
	    //memcpy(source, dest, size);
	    memcpy(source+(local_lbound*element_size),
		   dest+(amount_transfered*element_size),
		   element_size*size);
	    break;
	} else {
	    //	    printf("local_lbound: %i\n",local_lbound);
	    //if we have to look at other segments too
	    //for updates
	    //memcpy(source, dest, size);
	    memcpy(source+(local_lbound*element_size),
		   dest+(amount_transfered*element_size),
		   element_size*(blocksize-(local_lbound%blocksize)));

	    amount_transfered+=(blocksize-(local_lbound%blocksize));
	    lbound += (blocksize-(local_lbound%blocksize));
	    size -= (blocksize-(local_lbound%blocksize));
	}
    }
}

void handle_mirrors_and_updates(DataManager* dataManagers){
    //go through the blockArrayInfos and the cyclicArrayInfos of each
    //spu and take care of transfers
    BlockArrayInfo* tmp_bai;
    BlockArrayInfo* bpos;
    CyclicArrayInfo* tmp_cai;
    CyclicArrayInfo* cpos;
    int i;
    //handle reads
#ifdef DEBUG_PPU_MIRROR_UPDATE
    printf("mirrors\n");
#endif
    for(i=0;i<GROUP_SIZE;i++){
	tmp_bai = dataManagers[i].thisgroup->clist->block_info;
	while(tmp_bai != NULL){
	    if(tmp_bai->request == MIRROR_VARIABLE){
#ifdef DEBUG_PPU_MIRROR_UPDATE
		printf("handling mirror block array\n");
#endif
		handle_mirror_variable_b(dataManagers,tmp_bai,i);
		//remove the variable from the list
		if(tmp_bai->prev != NULL){
		    tmp_bai->prev->next = tmp_bai->next;
		} else {
		    dataManagers[i].thisgroup->clist->block_info = tmp_bai->next;
		}
		if(tmp_bai->next != NULL)
		    tmp_bai->next->prev = tmp_bai->prev;
		bpos = tmp_bai->next;
		free(tmp_bai);
		tmp_bai = bpos;
	    } else {
		tmp_bai = tmp_bai->next;
	    }
	}
	tmp_cai = dataManagers[i].thisgroup->clist->cyclic_info;
	while(tmp_cai != NULL){
	    if(tmp_cai->request == MIRROR_VARIABLE){
		handle_mirror_variable_c(dataManagers,tmp_cai,i);
		//remove the variable from the list
		if(tmp_cai->prev != NULL){
		    tmp_cai->prev->next = tmp_cai->next;
		} else {
		    dataManagers[i].thisgroup->clist->cyclic_info = tmp_cai->next;
		}
		if(tmp_cai->next != NULL)
		    tmp_cai->next->prev = tmp_cai->prev;
		cpos = tmp_cai->next;
		free(tmp_cai);
		tmp_cai = cpos;
	    } else {
		tmp_cai = tmp_cai->next;
	    }
	}
    }
#ifdef DEBUG_PPU_MIRROR_UPDATE
    printf("updates\n");
#endif
    //handle writes
    for(i=0;i<GROUP_SIZE;i++){
	tmp_bai = dataManagers[i].thisgroup->clist->block_info;
	while(tmp_bai != NULL){
	    if(tmp_bai->request == UPDATE_VARIABLE){
#ifdef DEBUG_PPU_MIRROR_UPDATE
		printf("handling update block array\n");
#endif
		handle_update_variable_b(dataManagers,tmp_bai,i);
		//remove the variable from the list
		if(tmp_bai->prev != NULL){
		    tmp_bai->prev->next = tmp_bai->next;
		} else {
		    dataManagers[i].thisgroup->clist->block_info = tmp_bai->next;
		}
		if(tmp_bai->next != NULL)
		    tmp_bai->next->prev = tmp_bai->prev;
		bpos = tmp_bai->next;
		free(tmp_bai);
		tmp_bai = bpos;
	    } else {
		tmp_bai = tmp_bai->next;
	    }
	}
	tmp_cai = dataManagers[i].thisgroup->clist->cyclic_info;
	while(tmp_cai != NULL){
	    if(tmp_cai->request == UPDATE_VARIABLE){
#ifdef DEBUG_PPU_MIRROR_UPDATE
		printf("handling update cyclic array\n");
#endif
		handle_update_variable_c(dataManagers,tmp_cai,i);
		//remove the variable from the list
		if(tmp_cai->prev != NULL){
		    tmp_cai->prev->next = tmp_cai->next;
		} else {
		    dataManagers[i].thisgroup->clist->cyclic_info = tmp_cai->next;
		}
		if(tmp_cai->next != NULL)
		    tmp_cai->next->prev = tmp_cai->prev;
		cpos = tmp_cai->next;
		free(tmp_cai);
		tmp_cai = cpos;
	    } else {
		tmp_cai = tmp_cai->next;
	    }
	}
    }
}

void NestStep_combine(DataManager* dataManagers){
#ifdef DEBUG_COMBINE
    printf("Combine started\n");
#endif
    //handle rep-arrays
    handle_RepArrays(dataManagers);
    //handle shvars
    handle_ShVars(dataManagers);
    //handle mirrors and updates
    handle_mirrors_and_updates(dataManagers);
    clear_CombineList(dataManagers);
#ifdef DEBUG_COMBINE
    printf("Combine completed\n");
#endif
    return;
}

void clear_CombineList(DataManager* dataManagers){
    int i;
    for(i=0;i<GROUP_SIZE;i++){
	free_CombineList(dataManagers[i].thisgroup->clist);
	dataManagers[i].thisgroup->clist = new_CombineList();
    }
}

CombineList* new_CombineList(){
    //    CombineList* tmp = malloc(sizeof(CombineList));
    
    //needs to be 16byte aligned so we can transfer it.
    CombineList* tmp = (CombineList*)memalign(16, sizeof(CombineList));
    tmp->combine_items = NULL;
    tmp->combine_info = NULL;
    tmp->no_combine_items = 0;
    tmp->prefix_vars = NULL;
    tmp->no_prefix_vars = 0;
    tmp->rep_info = NULL;
    tmp->no_rep_arrays = 0;
    tmp->block_info = NULL;
    tmp->no_block_arrays = 0;
    tmp->cyclic_info = NULL;
    tmp->no_cyclic_arrays = 0;
    tmp->request_id_counter = 0;
    tmp->NDAmsgs = NULL;

    return tmp;
}

void free_CombineList(CombineList* _clist){
    //    int i;
    //    printf("free combinelist: %x\n",_clist);
    //do i need to handle combine_infos in this loop too?
    //    CombineItem* citem = _clist->combine_items;
    //    PrefixVar* pvar = _clist->prefix_vars;
    CombineInfo* cinfo = _clist->combine_info;
    RepArrayInfo* rainfo = _clist->rep_info;
    BlockArrayInfo* bainfo = _clist->block_info;
    CyclicArrayInfo* cainfo = _clist->cyclic_info;

//    while(citem != NULL){
//	_clist->combine_items = _clist->combine_items->next;
//	free(citem);
//	citem = _clist->combine_items;
//    }
//    _clist->no_combine_items = 0;

//    while(pvar != NULL){
//	_clist->prefix_vars = _clist->prefix_vars->next;
//	free(pvar->child_values);
//	free(pvar->prefix);
//	free(pvar);
//	pvar = _clist->prefix_vars;
//    }
//    _clist->no_prefix_vars = 0;

    while(cinfo != NULL){
	_clist->combine_info = _clist->combine_info->next;
	free(cinfo->combineFn);
	free(cinfo);
	cinfo = _clist->combine_info;
    }
    _clist->no_combine_items = 0;

    while(rainfo != NULL){
	_clist->rep_info = _clist->rep_info->next;
	//	free(rainfo->old_base);
	//	free(rainfo->prefix_base);
	//	free(rainfo->child_arrays);
	//	free(rainfo->combineFn);
	free(rainfo);
	rainfo = _clist->rep_info;
    }
    _clist->no_rep_arrays = 0;
    while(bainfo != NULL){
	_clist->block_info = _clist->block_info->next;
	free(bainfo);
	bainfo = _clist->block_info;
    }
    _clist->no_block_arrays = 0;

    while(cainfo != NULL){
	_clist->cyclic_info = _clist->cyclic_info->next;
	free(cainfo);
	cainfo = _clist->cyclic_info;
    }
    _clist->no_cyclic_arrays = 0;

	// added by Markus lind (Some cals to this functions assumed it was free, some didn't...
	free(_clist);
	
    return;
}

//attach a combinefunction and bind a name to it so that it can be referenced from the spu
//when running combine
//NOTE: how do I manage combine functions? not at all, don't allow them.
//void NestStep_attach_combineFn(char* _functionName, 
//                               void* _combineFn);

//This functions attaches a shared variable to the combine-list that is used
//to get a consistent state after a step-statement
void NestStep_ShVar_attach(ShVar *_var, 
                           int _combine_strategy,
                           void (*_combineFn)(void*, void*, void*),
                           int _prefix_tag,
                           Addr64 _prefix_base,
                           int _updated,
                           CombineList* _clist,
			   int spu_id){
    CombineInfo* tmp_cinfo = memalign(16,sizeof(CombineInfo));
    tmp_cinfo->var = _var;
    tmp_cinfo->type = _var->type;
    tmp_cinfo->combine_strategy = _combine_strategy;
    tmp_cinfo->combineFn = _combineFn;
    tmp_cinfo->updated = _updated;
    tmp_cinfo->prev = NULL;
    tmp_cinfo->next = _clist->combine_info;
    //TODO: 
    // what about _prefix_tag?
    tmp_cinfo->prefix_tag = _prefix_tag;
    // what about _prefix_base?
    tmp_cinfo->prefix_base = _prefix_base.p;

    if(_clist->no_combine_items)
	_clist->combine_info->prev = tmp_cinfo;
    
    _clist->combine_info = tmp_cinfo;
    _clist->no_combine_items++;
    return;
}
//This function attaches a replicated array to the combine-list that is used
//to get a consistent state after a step-statement, inside the RepArray a
//lower and higher bound should be set to indicate what parts of the array
//should be combined
void NestStep_RepArray_attach(RepArray *_array,
                              int _combine_strategy,
                              void (*_combineFn)(void*, void*, void*),
                              int _prefix_tag,
                              Addr64 _prefix_base,
                              int updated,
                              CombineList *_clist,
			      int spu_id){
    RepArrayInfo* tmp_rinfo = memalign(16,sizeof(RepArrayInfo));
    tmp_rinfo->rep_array = _array;
    tmp_rinfo->type = _array->type;
    tmp_rinfo->combine_strategy = _combine_strategy;
    tmp_rinfo->combineFn = _combineFn;
    tmp_rinfo->prefix_base = _prefix_base.p;
    tmp_rinfo->next = _clist->rep_info;
    tmp_rinfo->prev = NULL;
    tmp_rinfo->updated = updated;
    //TODO:
    // what about prefix_tag?
    tmp_rinfo->prefix_tag = _prefix_tag;
    tmp_rinfo->prefix_base = _prefix_base.p;
    // what about old_base?
    // - remove
    // what about child_arrays?
    // - remove
    if(_clist->no_rep_arrays)
	_clist->rep_info->prev = tmp_rinfo;
    _clist->rep_info = tmp_rinfo;
    _clist->no_rep_arrays++;
    return;
}

// sets the range for which the combine-function should affect the
// array, will stay in effect until after the next combine
int NestStep_RepArray_range(RepArray *_array, 
			    int _lower, 
			    int _higher,
			    int spu_id){
    _array->url = _lower;
    _array->urh = _higher;
    return 0;
}


//these functions transform a local index to a global index and
//from global to local respectively.
//returns OUT_OF_BOUNDS if the index is higher than the segment
//and OUT_OF_BOUNDS if the index is lower than the segment
int global_local_index_b(BlockDistArray *array, int index, int spu_no){
    if(index < array->lower){
	return OUT_OF_BOUNDS;
    }
    if(index > array->higher){
	return OUT_OF_BOUNDS;
    }
    return index - array->lower;
}
int local_global_index_b(BlockDistArray *array, int index, int spu_no){
    if(index < 0){
	return OUT_OF_BOUNDS;
    }
    if(index > array->higher - array->lower){
	return OUT_OF_BOUNDS;
    }
    return index + array->lower;

}
int global_local_index_c(CyclicDistArray *array, int index, int spu_no){
    int remainder, ratio;

    if(index < 0){
	return OUT_OF_BOUNDS;
    }
    if(index > array->size){
	return OUT_OF_BOUNDS;
    }
    remainder = index % (array->blocksize * GROUP_SIZE);
    ratio = index / (array->blocksize * GROUP_SIZE);

    if(remainder >= (spu_no * array->blocksize) &&
       remainder < ((spu_no + 1) * array->blocksize)){

	return ratio * array->blocksize + 
	    remainder - 
	    spu_no * array->blocksize;
    }
    else {
	return OUT_OF_BOUNDS;
    }
}
int local_global_index_c(CyclicDistArray *array, int index, int spu_no){
    int gindex;
    
    //get which block it is in
    gindex = (index / array->blocksize)*array->blocksize*GROUP_SIZE;
    //get the rank-offset within the block
    gindex += spu_no * array->blocksize;
    //get the offset within the rank
    gindex += index % array->blocksize;

    if(gindex < 0){
	return OUT_OF_BOUNDS;
    }
    if(gindex > array->size){
	return OUT_OF_BOUNDS;
    }
    return gindex;
}
