#ifndef BASE_SPU_H
#define BASE_SPU_H

//Common functions and variables for ppu and spu, common_nestste.h
//includes the rest recursively.
#include "../NestStep_common/common_neststep.h"

//#include <spu_intrinsics.h>
//#include <spu_internals.h>
//SPU specific includes for memory management
//#include <cbe_mfc.h>
//#include <libmisc.h>
#include <spu_mfcio.h> // mfc_mbox, dma, etc
#include <stdlib.h> // exit()
#include <stdio.h> // malloc
#include <errno.h> // ernno, strerror() perror..

//NOTE: filehandle for debugging the damn spe:s
FILE *debugfile;

//NestStep spu variables
DataManager dataManager;
//address of the dataManager in main memory
Addr64 dataManagerAddress;
//DMA-tag 31 is used by the system
#define NESTSTEP_DMA_TAG 1

//these defines are for error handling of programmer-code
//i.e. check if offsets are correct inside NestStep-programs.
#define TEST_SIZE_OFFSET 1
#define TEST_SIZE 2
#define TEST_MMADDR 3
#define TEST_LSADDR 4
#define TEST_BOUNDS 5

//function for storing and retreiving the mboxExtraData to memory
//NOTE: this could be done by sending several mails into the mbox
//instead of using a memoryblock, but i think this might be more
//efficient.. and it feels safer, especially since messages get doubled etc.
void write_mboxExtraData();
void read_mboxExtraData();

//listing of all available DMA-channels(0-30)
//NOTE: this has been superceeded by the following function
//and the handling has been split into a part that is inside
//each variable and a part that is inside the datamanager
int get_available_mfc_chan();

void check_dma(char* fn, int lbound, int ubound, 
	       void* lsaddr, void* mmaddr, int type, int test);


//set tag
void set_tag(Dma_tag* tag, int tagnumber, Addr64 address);
//remove tag
void remove_tag(Dma_tag* tag, Addr64 address);
//find tag
int find_tag(Dma_tag* tag, Addr64 address);
Dma_tag* new_tag();
void free_tag(Dma_tag* tmp);


#endif // BASE_SPU_H
