#ifndef COMBINE_SPU_H
#define COMBINE_SPU_H

#include "base_spu.h"
//#include "../NestStep_common/common_neststep.h"

//#include "neststep_spu.h"

//the combineFn is declared and attached to a combine-function list
//on the ppu since code compiled for the spu can't run on the ppu..

//This function is called after a step-statement, it should be called
//with both it's parameters set to NULL. the variables are there if
//we want to run combine on another group


void NestStep_combine(CombineList *_clist, ArrayHolder *_holder);

//This functions attaches a shared variable to the combine-list that is used
//to get a consistent state after a step-statement
void NestStep_ShVar_attach(ShVar *_var, 
                           int _combine_strategy,
                           char* _combineFnName, //void (*_combineFn)(void*, void*, void*),
                           int _prefix_tag,
                           PVar* _prefix_var,
                           int _updated,
                           CombineList* _clist);
//void NestStep_ShVar_attach(ShVar *_var, 
//                           int _combine_strategy,
//                           char* _combineFnName, //void (*_combineFn)(void*, void*, void*),
//                           int _prefix_tag,
//                           Addr64 _prefix_base,
//                           int _updated,
//                           CombineList* _clist);

//This function attaches a replicated array to the combine-list that is used
//to get a consistent state after a step-statement, inside the RepArray a
//lower and higher bound should be set to indicate what parts of the array
//should be combined
void NestStep_RepArray_attach(RepArray *_array,
                              int _combine_strategy,
                              char* _combineFnName, //void (*_combineFn)(void*, void*, void*),
                              int _prefix_tag,
                              PrivateArray* _prefix_array,
                              int updated,
                              CombineList *_clist);
//void NestStep_RepArray_attach(RepArray *_array,
//                              int _combine_strategy,
//                              char* _combineFnName, //void (*_combineFn)(void*, void*, void*),
//                              int _prefix_tag,
//                              Addr64 _prefix_base,
//                              int updated,
//                              CombineList *_clist);

// sets the range for which the combine-function should affect the
// array, will stay in effect until after the next combine
int NestStep_RepArray_range(RepArray *_array, int _lower, int _higher);

#endif // COMBINE_SPU_H
