#ifndef TREE_BUILDERS_SPU_H
#define TREE_BUILDERS_SPU_H

#include "../NestStep_common/common_neststep.h"

//Constants to define what kind of combine-tree it is
#define FLAT 0
#define DARY 1
#define BIO 2

//functions to create and destroy a combine-tree
int new_Tree(void);
int free_Tree(void);

//this function has to be called  after a tree has changed in some way
int rebuild_tree(void);
//this function changes a tree to be a d-ary tree, needs to call 
//rebuild_tree() afterwards
int change_tree_dary(int _dval);
//this function changes a tree to be a flat tree, needs to call 
//rebuild_tree() afterwards
int change_tree_flat(void);
//this function changes a tree to be a binomial tree, needs to call 
//rebuild_tree() afterwards
int change_tree_bin(double _bval);

//this function builds a binomial tree with the specified input
int build_tree(int _nodes, 
               int _rank, 
               int* _parent, 
               int* _no_children, 
               int** _children);
//this function builds a d-ary tree with the specified input
void build_d_tree(int _lower, 
                  int _higher, 
                  int _rank, 
                  int* _parent, 
                  int* _no_children, 
                  int** _children, 
                  int _d);
//this function builds a flat tree with the specified input
void build_flat_tree(int _nodes,
                     int _rank, 
                     int* _parent,
                     int* _no_children,
                     int** _children);

//NOTE: what does this do? doesnt matter.
void skewed_tree(int _lower,
                 int _higher,
                 double _ratio,
                 int _rank,
                 int* _parent,
                 int* _no_children,
                 int** _children);
//NOTE: what does this do? doesnt matter.
void skewed_tree_init(int _nodes,
                      double _ratio,
                      int _rank,
                      int* _parent,
                      int* _no_children,
                      int** _children);

#endif //TREE_BUILDERS_SPU_H
