#!/bin/bash

# call with ./print_code.sh printer

# get first argument, if --? or --help or none, print error message

PRINTERS=`lpstat | sed "s/\@/ /g" | awk '{print $2}'`
#PRINTERS="foo bar tar"
OK_PRINTER="false"

#check if the user has supplied a valid argument
if [ -n "$1" ];
then
    PRINTER=$1
    # check if the printer is allowed
    for pr in ${PRINTERS}; do
	if [ "$PRINTER" = $pr ];
	then
	        OK_PRINTER="true"
	fi
    done
    # if not, print error message
    if [ "$OK_PRINTER" = "false" ];
    then
	echo "call with $0 [printer]"
	echo "where [printer] is one of"
	echo ${PRINTERS}
    # everything is ok, list all code and header files
    else
	for i in $(find . | egrep -v "\.svn" | egrep "*\.h|*\.c"); do
#	    a2ps $i | lp -d ${PRINTER}
	    echo "$i | lp -d ${PRINTER}
	done
    fi
# if the user hasn't supplied a valid argument, print error message
else
    echo "call with $0 [printer]"
    echo "where [printer] is one of"
    echo ${PRINTERS}
fi

#grep all .h and .c files and run a2ps on them and send the output to
#lp -d ${PRINTER}
