/* ********************************************** *
 * spu-part of the test-program, will use spu-lib *
 * to communicate with the ppu-part this is step1 *
 * ********************************************** */

#include <stdio.h>
#include <../../NestStep_spulib/neststep_spu.h>

#define N 10000000

double f( double x )
{
    return  4.0/(1.0 + x*x );
}

int main(unsigned long long speid, Addr64 argp, Addr64 envp)
    //void main( int argc, char *argv[] )
{
    NestStep_SPU_init(argp);
    Name name;
    name.procedure = 1;
    name.relative = 0;
    //    sh float pi;
    double *_pi;
    ShVar *pi = new_ShVar(name,DVAR,(Addr64)(void*)_pi);

    //    sh float h<=>;   // shared constant
    double *_h;

    name.relative++;
    ShVar *h = new_ShVar(name,DVAR,(Addr64)(void*)_h);

    int i;

    NestStep_step();
    {
//	_pi = get_ShVarD(pi);
//	_h = get_ShVarD(h);
//	wait_ShVar_complete(pi);
//	wait_ShVar_complete(h);
	_pi = malloc(sizeof(double));
	_h = malloc(sizeof(double));
	*_h = 1.0 / (double)N;
	*_pi = 0;
	for (i=NestStep_get_rank(); i<N; i+=NestStep_get_size())
	    *_pi += f( (*_h)*((double)i - 0.5));

//	for (i=NestStep_get_rank(); i<N; i+=NestStep_get_size()){
//	    *_pi += 4.0/(1+ ((*_h)*((double)i-0.5)*(*_h)*((double)i-0.5)));
//	    i+=NestStep_get_size();
//	    *_pi += 4.0/(1+ ((*_h)*((double)i-0.5)*(*_h)*((double)i-0.5)));
//	}
	store_ShVarD(pi,(Addr64)_pi);
	wait_ShVar_complete(pi,(Addr64)_pi);

	NestStep_ShVar_attach(pi, ADD, NULL, NO_PREFIX,NULL, NOT_UPDATED, NULL); 
    }
    //    combine ( pi<+> );
    NestStep_combine(NULL,NULL);

    NestStep_step();
    {
	get_ShVarD(pi,(Addr64)_pi);
	wait_ShVar_complete(pi,(Addr64)_pi);
	*_pi = (*_pi)*(*_h);
	if (NestStep_get_rank()==0)
	    printf("PI=%f\n", *_pi );
    }
    NestStep_combine(NULL,NULL);
    //    combine ( pi<=> ); // no combine

    NestStep_SPU_finalize();
}

//  #include "../NestStep_spulib/neststep_spu.h"
//  
//  int main(unsigned long long speid, Addr64 argp, Addr64 envp) {
//      int ii=0;
//      //spu part1
//      NestStep_SPU_init(argp);
//      Name name;
//      name.procedure = 1;
//      name.relative = 0;
//      //sh int a; // rep var
//      int *_a;
//      //    printf("sleep\n");
//      printf("1\n");
//      ShVar *a = new_ShVar(name, IVAR,(Addr64)_a);
//      //ShVar *a = NULL;
//      //sh int b;
//      int *_b; // rep var
//      name.relative++;
//      ShVar *b = new_ShVar(name, IVAR, (Addr64)_b);
//      //sh int c[5]<%>; // cyclic arr
//          name.relative++;
//          CyclicDistArray *c = new_CyclicDistArray(name, IVAR, 12, DEFAULT_BLOCKSIZE/sizeof(int)); 
//      //sh int d[5]</>; // block arr
//  	//        name.relative++;
//  	//        BlockDistArray *d = new_BlockDistArray(name, IVAR, 12);
//      //    printf("2\n");
//      //sh int e[6]<%>[7]; // cyclic arr on first index
//  	//        CyclicDistArray *e[7];
//  	//        for(ii=0;ii<7;ii++){
//  	//    	name.relative++;
//  	//    	e[ii] = new_CyclicDistArray(name, IVAR, 10, DEFAULT_BLOCKSIZE/sizeof(int)); 
//  	//        }
//          int *_f; // priv var
//          name.relative++;
//          PVar* f = new_PVar(name, IVAR, (Addr64)_f);
//      //    int g[5]; // priv arr
//      //sh<?> int k[20]; // rep arr with combine-function set 
//                         // to other than default, if the variable is combined
//                         // inside a step, then the selected combine-operation
//                         // will be chosen there, this is because it is only
//                         // inside a combine-info item that the strategy is
//                         // stored and we don't have that item here.
//  //    int _k[20];
//  //    name.relative++;
//  //    RepArray *k = new_RepArray(name, IVAR, 20, (Addr64)_k);
//  //    printf("3\n");    
//  //    //step { 
//      NestStep_step();
//      {
//  //	int h; // priv var
//  //	//sh int i; // rep var
//  	int *_i;
//  		name.relative++;
//  		ShVar *i = new_ShVar(name, IVAR, (Addr64)_i);
//  //	//sh int j[5]</> // block arr
//  //	name.relative++;
//  //	BlockDistArray *j = new_BlockDistArray(name, IVAR, 5);
//  	//	int *_b2 = get_ShVarI(b);
//  	//	int* _j2 = get_BArrI(j,0,5);
//  //	int* _k2 = get_RArrI(k,0,20);
//  //	wait_ShVar_complete(b);
//  	//	wait_BArr_complete(j);
//  //	wait_RArr_complete(k);
//  //	//forall(h in j){
//  //	for(h=0;h<j->localsize;h++){
//  //	    _b2 += ((int *)_j2)[h];
//  //	    ((int *)_j2)[h]=h;
//  //	}
//  //	store_BArrI(j,(Addr64)_j2,0,5); //written by the user, indexes handled by the user.
//  //	store_ShVarI(b,_b2);
//  //	wait_ShVar_complete(b);
//  //	wait_BArr_complete(j);
//  //	//TODO: attach a, b, f, k to combinelist
//  //	//f is not in the correct scope.. it is in spu private context, 
//  //	//it needs to be declared as new_PVar so it is accessible by the ppe
//  //	NestStep_ShVar_attach(a, ADD, NULL, PREFIX,(Addr64)_f, NOT_UPDATED, NULL); 
//  //	NestStep_ShVar_attach(b, ADD, NULL, NO_PREFIX,(Addr64)(void*)NULL, NOT_UPDATED, NULL);
//  //	k->url = 0;
//  //	k->urh = 5;
//  //	NestStep_RepArray_attach(k,ADD,NULL,NO_PREFIX,(Addr64)(void*)NULL,NOT_UPDATED,NULL);
//  //	printf("4\n");
//      }
//  //    // combine(b<+>,a<+:f>,k[0:5]<+>); // TODO: i, j out of scope, how is this handled?    
//      NestStep_combine(NULL,NULL);
//      NestStep_end_step();
//  //    printf("5\n");
//  //    printf("NestStep_SPU_finalize()\n");
//      NestStep_SPU_finalize();
//      printf("After NestStep_SPU_finalize()\n");
//      exit(0); //TODO: now why can't the program exit normally?
//      //    printf("errno: %i\n", errno);
//      return 0;
//  }
