################################################################################
# Make rules
################################################################################

#TOOLCHAIN_HOME=/opt/sce/toolchain-2.3
TOOLCHAIN_HOME=/opt/cell/toolchain-3.3
DEVEL_HOME=/home/astrolite/code/CELL/tmphome

################################################################################
# spe compiler definition
################################################################################
speEMB=ppu-embedspu
speEMBFLAGS=-m32
#speEMBFLAGS=-m64
speAR=ppu-ar
speARFLAGS=-qcs
#speLDFLAGS = /opt/cell/sysroot/usr/spu/lib/libc.a /opt/cell/sysroot/usr/spu/lib/libsim.a -Wl,-N
#speLDFLAGS = /opt/cell/sysroot/usr/spu/lib/libsim.a -Wl,-N
#speLDFLAGS = /opt/cell/sysroot/usr/spu/lib/libmath.a /opt/cell/sysroot/usr/spu/lib/libsim.a /opt/cell/sysroot/usr/spu/lib/libc.a -Wl,-N
#speLDFLAGS +=  /opt/IBM/cell-sdk-1.1/sysroot/usr/spu/lib/libsim.a /opt/IBM/cell-sdk-1.1/sysroot/usr/spu/lib/libc.a /opt/IBM/cell-sdk-1.1/sysroot/usr/lib/libmisc.a -Wl,-N
#speLDFLAGS +=  /opt/IBM/cell-sdk-1.1/sysroot/usr/spu/lib/libsim.a /opt/IBM/cell-sdk-1.1/sysroot/usr/spu/lib/libc.a  -Wl,-N
#speLDFLAGS +=   /opt/cell/toolchain-3.3/spu/lib/libc.a -Wl,-N
speLDFLAGS +=    -Wl,-N
speCXX=spu-g++
speCXXLFLAGS=-x c++ -D_WCHAR_T -DDEBUG_OUTPUT
speCXXFLAGS=-O3

#speCXXINCLUDES=-I /opt/IBM/cell-sdk-1.1/sysroot/usr/spu/include -I .. -I . -I ${DEVEL_HOME}
speCXXINCLUDES=-I /opt/ibm/cell-sdk/prototype/sysroot/usr/spu/include -I .. -I . -I ${DEVEL_HOME}

#add some includes to fix the broken sdk
#speCINCLUDES= -I/opt/IBM/cell-sdk-1.1/sysroot/usr/lib/gcc/spu/4.0.2/include/
#speCINCLUDES+= -I/opt/IBM/cell-sdk-1.1/src/include/spu/
speCINCLUDES= -I/opt/ibm/cell-sdk/prototype/src/include/spu/

#original spu-include line
#speCINCLUDES+=-I /opt/IBM/cell-sdk-1.1/sysroot/usr/spu/include -I .. -I . -I ${DEVEL_HOME}
speCINCLUDES+=-I /opt/ibm/cell-sdk/prototype/sysroot/usr/spu/include -I .. -I . -I ${DEVEL_HOME}
ifeq "${SPU_COMPILER}" "spuxlc"
	speCC=spuxlc
	spe_optflags=-O3
	spe_altivec=-D __ALTIVEC_LITERAL_STYLE__ -qcpluscmt
	speCFLAGS=${spe_optflags} ${spe_altivec}
	speCLFLAGS=-qsourcetype=c
else
	speCC=spu-gcc
	spe_optflags=-O3
	ifeq "${CELLBUILDTYPE}" "DEBUG"
		speCFLAGS=${spe_optflags} -fstack-check -g
	else
		speCFLAGS=${spe_optflags}
	endif
	speCLFLAGS=-x c
endif




%.o: %.c
	${speCC} ${speCFLAGS} ${speCLFLAGS} ${speCINCLUDES} -c $< -o $@

%.o: %.cpp
	${speCXX} ${speCXXFLAGS} ${speCXXLFLAGS} ${speCXXINCLUDES} -c $< -o $@

# subdirs
.PHONY : subdirs ${SUBDIRS}

subdirs: ${SUBDIRS}

${SUBDIRS}:
	${MAKE} -C $@ ${MAKECMDGOALS}

# clean
.PHONY : clean

clean: ${SUBDIRS}
	rm -rf *.o *.lst ${TARGETS}
