/* ********************************************** *
 * spu-part of the test-program, will use spu-lib *
 * to communicate with the ppu-part this is step1 *
 * ********************************************** */

#include "../../NestStep_spulib/neststep_spu.h"

int main(unsigned long long speid, Addr64 argp, Addr64 envp) {
    int ii=0;
    int i = 0;
    //spu part1
    NestStep_SPU_init(argp);
    int rank = NestStep_get_rank();
    printf("%i, spu init\n",rank);
    if(NestStep_get_size() < 2){
	printf("Error, this program needs at least 2 SPUs\n");
	NestStep_SPU_finalize();
	exit(1);
    }
    Name name;
    name.procedure = 1;
    name.relative = 0;

    int *_a; // remove requirement on sending a dummy-address here?
    ShVar *a = new_ShVar(name, IVAR,(Addr64)_a);

    int *_b; // rep var
    name.relative++;

    ShVar *b = new_ShVar(name, IVAR, (Addr64)_b);

    name.relative++;
    CyclicDistArray *c = new_CyclicDistArray(name, IVAR, 12, DEFAULT_BLOCKSIZE/sizeof(int)); 


    name.relative++;
    BlockDistArray *d = new_BlockDistArray(name, IVAR, 16);

    CyclicDistArray *e[7];
    for(i=0;i<7;i++){
	name.relative++;
	e[i] = new_CyclicDistArray(name, IVAR, 16, DEFAULT_BLOCKSIZE/sizeof(int)); 
    }

    int *_f; // priv var
    name.relative++;
    PVar* f = new_PVar(name, IVAR, (Addr64)_f);
    int g[5]; // priv arr
    //sh<?> int k[20]; // rep arr with combine-function set 
                       // to other than default, if the variable is combined
                       // inside a step, then the selected combine-operation
                       // will be chosen there, this is because it is only
                       // inside a combine-info item that the strategy is
                       // stored and we don't have that item here.
    int _k[20];

    name.relative++;
    RepArray *k = new_RepArray(name, IVAR, 32, (Addr64)_k);

    name.relative++;
    int* _p;
    PrivateArray *p = new_PrivateArray(name,IVAR,32,(Addr64)_p);

    name.relative++;
    BlockDistArray *bj = new_BlockDistArray(name, IVAR, 16*8);

    // 16 elements in each block.. this is suboptimal but it gives us two blocks per spu instead
    // of one. DEFAULT_BLOCKSIZE is 128 byte = 32 ints..
    name.relative++;
    CyclicDistArray *cj = new_CyclicDistArray(name,IVAR,16*8,DEFAULT_BLOCKSIZE/sizeof(int)/2); 
    printf("cj blocksize: %i\n",DEFAULT_BLOCKSIZE/sizeof(int)/2);

    name.relative++;
    PrivateArray *pj;
    pj = new_PrivateArray(name,IVAR,16*8,(Addr64)_p);

    name.relative++;
    PrivateArray *pbj;
    pbj = new_PrivateArray(name,IVAR,16*8,(Addr64)_p);

    name.relative++;
    PrivateArray *pcj;
    pcj = new_PrivateArray(name,IVAR,16*8,(Addr64)_p);

    NestStep_step();
    {
	if(NestStep_get_rank() == 2){
	    int* tmp = malloc(16*8*sizeof(int));
	    printf("tmp = \n");
	    for(i=0;i<16*8;i++){
		tmp[i] = i;
		printf("%i,",i);
	    }
	    printf("\n");
	    store_PArrI(pj,(Addr64)tmp,0,16*8-1);
	    wait_PArr_complete(pj,(Addr64)tmp);
	    write_request_b(pj,bj,0,16*8-1);
	    write_request_c(pj,cj,0,16*8-1);
	    free(tmp);
	}
    }
    NestStep_combine(NULL,NULL);

    NestStep_end_step();

    NestStep_step();
    {
	int aa = NestStep_get_rank() + 10;

	store_ShVarI(a,(Addr64) &aa);
	wait_ShVar_complete(a,(Addr64)&aa);

	int* _j2 = malloc(32*sizeof(int));
	int* _k2 = malloc(16*sizeof(int));
	int *_pj2 = malloc(16*8*sizeof(int));
	for(i=0;i<32;i++){
	    _j2[i] = NestStep_get_rank()*32+i;
	}
	for(i=0;i<16;i++){
	    _k2[i] = i + NestStep_get_rank()*10;
	}

//	store_BArrI(bj,(Addr64)_j2,NestStep_get_rank()*32,(((NestStep_get_rank()+1)*32)-1));
//	store_CArrI(cj,(Addr64)_j2,NestStep_get_rank()*16,(((NestStep_get_rank()+1)*16)-1));
//
//	store_CArrI(cj,(Addr64)(_j2+16),
//		    NestStep_get_rank()*16+NestStep_get_size()*16,
//		    ((NestStep_get_rank()+1)*16)-1+NestStep_get_size()*16);
	store_RArrI(k,(Addr64)_k2,0,15);

	int _b2 = NestStep_get_rank();

	store_ShVarI(b,(Addr64)&_b2);
	wait_ShVar_complete(b,(Addr64)&_b2);
	wait_BArr_complete(bj,(Addr64)_j2);
	wait_CArr_complete(cj,(Addr64)_j2);
	wait_RArr_complete(k,(Addr64)_k2);

	if(NestStep_get_rank() == 2){
	    get_PArrI(pj,(Addr64)_pj2,0,16*8-1);
	    wait_PArr_complete(pj,(Addr64)_pj2);    
	    printf("Private array: \n");
	    for(i=0;i<16*8;i++){
		printf("%i,",_pj2[i]);
	    }
	    printf("\n");
	    free(_pj2);
	}

	if(NestStep_get_rank() == 3){
	    read_request_b(pbj,bj,0,16*8-1);
	    read_request_c(pcj,cj,0,16*8-1);
	}

	NestStep_ShVar_attach(a, ADD, NULL, PREFIX,f, NOT_UPDATED, NULL); 
	NestStep_ShVar_attach(b, MULT, NULL, NO_PREFIX,NULL, NOT_UPDATED, NULL);

	k->url = 0;
	k->urh = 5;
	
	NestStep_RepArray_attach(k,ADD,NULL,PREFIX,p,NOT_UPDATED,NULL);

    }
    // combine(b<+>,a<+:f>,k[0:5]<+>);
    NestStep_combine(NULL,NULL);

    NestStep_end_step();

    if(NestStep_get_rank() == 3){
	int *_pbj2 = malloc(16*8*sizeof(int));
	get_PArrI(pbj,(Addr64)_pbj2,0,16*8-1);
	int *_pcj2 = malloc(16*8*sizeof(int));
	get_PArrI(pcj,(Addr64)_pcj2,0,16*8-1);
	printf("_pbj2: %x, _pcj2: %x\n",_pbj2,_pcj2);
	wait_PArr_complete(pbj,(Addr64)_pbj2);
	wait_PArr_complete(pcj,(Addr64)_pcj2);
	printf("bparr: %x\n",pbj->base.p);
	printf("cparr: %x\n",pcj->base.p);
	printf("Block distributed array: \n");
	for(i=0;i<16*8;i++){
	    printf("%i,",_pbj2[i]);
	}
	printf("\n");
	free(_pbj2);

	printf("Cyclic distributed array: \n");
	for(i=0;i<16*8;i++){
	    printf("%i,",_pcj2[i]);
	}
	printf("\n");
	free(_pcj2);
    }
    

    int _a3;
    get_ShVarI(a,(Addr64)&_a3);
    wait_ShVar_complete(a,(Addr64)&_a3);

    int _f3;
    get_PVarI(f,(Addr64)&_f3);
    wait_PVar_complete(f,(Addr64)&_f3);

    int _b3;
    get_ShVarI(b,(Addr64)&_b3);
    wait_ShVar_complete(b,(Addr64)&_b3);
    
    int _p3[16];
    get_PArrI(p,(Addr64)_p3,0,15);
    wait_PArr_complete(p,(Addr64)_p3);
    if(NestStep_get_rank() == 3){
	printf("RepArray prefix:\n");
	for(i=0;i<16;i++){
	    printf("[%i]",_p3[i]);
	}
	printf("\n");
	printf("Should be:\n");
	for(i=0;i<16;i++){
	    printf("[%i]",30+3*i);
	}
	printf("\n");
    }

    NestStep_SPU_finalize();
    printf("%i, After NestStep_SPU_finalize()\n",rank);

    return 0;
}
