/* ********************************************** *
 *       Parallell prefix computation             *
 * ********************************************** */

#include <stdio.h>
#include <../../NestStep_spulib/neststep_spu.h>
#include "spu_time.h"
#include "reduce.h"
// Used for transforming clock-ticks to
// seconds, gotten from /proc/cpuinfo
//#define TIMEBASE 14318000
#define TIMEBASE 79800000
// Initialization value for the counter
#define DEC_INIT_VAL 0XFFFFFFFF

// Variables for handling the counters
int ublock1, ublock2, ublocktot;
int twait1, twait2, twaittot;
int ncomb1, ncomb2, ncombtot;
int timetmp1, timetmp2, timetmptot;
int timetmp3, timetmp4, timetmptot2;
spu_timer total_time;
spu_timer exec_time;
spu_timer dma_time;
spu_timer comb_time;
spu_timer calc_time;


//on ps3
//#define N 1048576*4
//on cell
//#define N (1024*1024*8)

//int N = 1024*1024*4;
int N = 1024*1024*24;

int MY_RANK;

float *_parPrefix;
PVar  *parPrefix;
float *_sum;
ShVar *sum;
float _pre1[4096];
float _pre2[4096];
PrivateArray* pre;
BlockDistArray* x;
float buffer1[4096];
float buffer2[4096];


float add(float left, float right)
{
	return left+right;
}


void calculate_parprefix(){
    int i, j, no_chunks;
    i = j = 0;
    no_chunks = (N/4096)/NestStep_get_size();
	float tstSum=0;
//	float (*red_func)(float, float) = NULL;
	
    //initialize variables x and with data 0 -> 1024*1024 using doublebuffering
    NestStep_step();
    {
	for(j=0;j<4096;j++){
	    buffer1[j] = j + MY_RANK*4096*no_chunks; // 64*4096
		tstSum +=    j + MY_RANK*4096*no_chunks;
	}
	store_BArrF(x,(Addr64)buffer1,
		    MY_RANK*no_chunks*4096,
		    MY_RANK*no_chunks*4096+4096-1);

	for (i=1; i<no_chunks; i++){
	    for(j=0;j<4096;j++){
			buffer2[j] = j + MY_RANK*no_chunks*4096+i*4096; // 64*4096
			tstSum +=    j + MY_RANK*no_chunks*4096+i*4096;
	    }
	    store_BArrF(x,(Addr64)buffer2,
			MY_RANK*no_chunks*4096+i*4096,
			MY_RANK*no_chunks*4096+i*4096+4096-1);

	    //twait1 = spu_read_decrementer();
	    wait_BArr_complete(x,(Addr64)buffer1);
	    //twait2 = spu_read_decrementer();
	    //	    twaittot+= twait1-twait2;
	    i++;
	    if(i >= no_chunks){
	        //twait1 = spu_read_decrementer();
		wait_BArr_complete(x,(Addr64)buffer2);
		//twait2 = spu_read_decrementer();
		//		twaittot+=twait1-twait2;
		break;
	    }

	    for(j=0;j<4096;j++){
			buffer1[j] = j + MY_RANK*no_chunks*4096 + i*4096; // 64*4096
			tstSum +=    j + MY_RANK*no_chunks*4096 + i*4096;
	    }
	    store_BArrF(x,(Addr64)buffer1,
			MY_RANK*no_chunks*4096+i*4096,
			MY_RANK*no_chunks*4096+i*4096+4096-1);
	    //	    printf("max local size: %i\n",i*4096+4096-1);
	    wait_BArr_complete(x,(Addr64)buffer2);
	}
//	printf("tstSum: %f\n", tstSum);
	tstSum = 0;
	for(i=0;i<N/4096;i++)
	{
		float tmp=0;
		for(j=0;j<4096;j++)
			tmp+=(float)(i*4096+j);
		tstSum+=tmp;
	}
	if(MY_RANK == 0)
		printf("tstSum: %f\n", tstSum);
	wait_BArr_complete(x,(Addr64)buffer1);
    }
    NestStep_combine(NULL,NULL);
    NestStep_end_step();

	*_sum = 0;
	
	float (*red_func)(float, float) = NULL;
	red_func = &add;

	//	printf("moo\n");
 	startTimer(&exec_time);
	
	*_sum = distReduce(red_func, x, N); 
	stopTimer(&exec_time);
	
//	printf("coo\n");

	NestStep_step();
//	if(MY_RANK==0)
//	{
//		get_ShVarF(sum,(Addr64)_sum);
//		wait_ShVar_complete(sum,(Addr64)_sum);
//		printf("reduce result: %f\n", *_sum);
//	}

	if(MY_RANK == 0)
		printf("lib reduce: %f\n", *_sum);
	NestStep_combine(NULL,NULL);
	NestStep_end_step();

//	NestStep_end_step();
 	
}

int main(unsigned long long speid, Addr64 argp, Addr64 envp)
{
    timetmp1 = timetmp2 =timetmptot=0;
    ublock1=ublock2=ublocktot=0;
    twait1=twait2=twaittot=0;
    ncomb1=ncomb2=ncombtot=0;
	
	total_time.time = 0;
	exec_time.time = 0;
	dma_time.time = 0;
	comb_time.time = 0;
	calc_time.time = 0;
	
    spu_write_decrementer(DEC_INIT_VAL);
    int i;


	
    NestStep_SPU_init(argp);
    MY_RANK = NestStep_get_rank();
    Name name;
    name.procedure = 1;
    name.relative = 0;

    _sum = malloc(sizeof(float));
    sum = new_ShVar(name,FVAR,(Addr64)(void*)NULL);
    name.relative++;

 //   pre = new_PrivateArray(name,FVAR,N/NestStep_get_size(),
//					 (Addr64)(void*)_pre1);

//    name.relative++;
    x = new_BlockDistArray(name,FVAR,N);
	startTimer(&total_time);
    for(i=0;i<1;i++){
		calculate_parprefix();
    }
	stopTimer(&total_time);

    if(MY_RANK==0){
//	printf("reduce result: %f\n", *parSum);
	printf("Tot programtime: %lld, %f\n",total_time.time, 
	       getTime(&total_time));
	printf("Tot executiontime: %lld, %f\n",exec_time.time, 
	       getTime(&exec_time));
	printf("Time spent calculating: %lld, %f\n",calc_time.time,
	       getTime(&calc_time));
	printf("Time spent waiting: %lld, %f\n",dma_time.time,
	       getTime(&dma_time));
	printf("Time spent in combine: %u, %f\n",ncombtot,
	       ((float)ncombtot)/TIMEBASE);
    }

    NestStep_SPU_finalize();

    return 0;
}
